<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:24 CEST 2019 -->
<title>FbBlob (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="FbBlob (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6,"i7":6,"i8":6,"i9":6,"i10":6,"i11":6,"i12":6,"i13":6,"i14":6,"i15":6,"i16":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/FbBlob.html" target="_top">Frames</a></li>
<li><a href="FbBlob.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng</div>
<h2 title="Interface FbBlob" class="title">Interface FbBlob</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Superinterfaces:</dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></dd>
</dl>
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/wire/FbWireBlob.html" title="interface in org.firebirdsql.gds.ng.wire">FbWireBlob</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/firebirdsql/gds/ng/AbstractFbBlob.html" title="class in org.firebirdsql.gds.ng">AbstractFbBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireBlob.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireInputBlob.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireInputBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/AbstractFbWireOutputBlob.html" title="class in org.firebirdsql.gds.ng.wire">AbstractFbWireOutputBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/jna/JnaBlob.html" title="class in org.firebirdsql.gds.ng.jna">JnaBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version10/V10InputBlob.html" title="class in org.firebirdsql.gds.ng.wire.version10">V10InputBlob</a>, <a href="../../../../org/firebirdsql/gds/ng/wire/version10/V10OutputBlob.html" title="class in org.firebirdsql.gds.ng.wire.version10">V10OutputBlob</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="typeNameLabel">FbBlob</span>
extends <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></pre>
<div class="block">Interface for blob operations.
 <p>
 All methods defined in this interface are required to notify all <code>SQLException</code> thrown from the methods
 defined in this interface.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Interface and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng">FbBlob.SeekMode</a></span></code>
<div class="block">Seek mode for <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#seek-int-org.firebirdsql.gds.ng.FbBlob.SeekMode-"><code>seek(int, org.firebirdsql.gds.ng.FbBlob.SeekMode)</code></a>.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#NO_BLOB_ID">NO_BLOB_ID</a></span></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#cancel--">cancel</a></span>()</code>
<div class="block">Cancels an output blob (which means its contents will be thrown away).</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#close--">close</a></span>()</code>
<div class="block">Closes the blob.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getBlobId--">getBlobId</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getBlobInfo-byte:A-int-">getBlobInfo</a></span>(byte[]&nbsp;requestItems,
           int&nbsp;bufferLength)</code>
<div class="block">Request blob info.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>&lt;T&gt;&nbsp;T</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getBlobInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">getBlobInfo</a></span>(byte[]&nbsp;requestItems,
           int&nbsp;bufferLength,
           <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)</code>
<div class="block">Request blob info.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getDatabase--">getDatabase</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getHandle--">getHandle</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getMaximumSegmentSize--">getMaximumSegmentSize</a></span>()</code>
<div class="block">The maximum segment size allowed by the protocol for <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getSegment-int-"><code>getSegment(int)</code></a> and <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#putSegment-byte:A-"><code>putSegment(byte[])</code></a>.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getSegment-int-">getSegment</a></span>(int&nbsp;sizeRequested)</code>
<div class="block">Gets a segment of blob data.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getSynchronizationObject--">getSynchronizationObject</a></span>()</code>
<div class="block">Get synchronization object.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#isEof--">isEof</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#isOpen--">isOpen</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#isOutput--">isOutput</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>long</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#length--">length</a></span>()</code>
<div class="block">Requests the blob length from the server.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#open--">open</a></span>()</code>
<div class="block">Opens an existing input blob, or creates an output blob.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#putSegment-byte:A-">putSegment</a></span>(byte[]&nbsp;segment)</code>
<div class="block">Writes a segment of blob data.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#seek-int-org.firebirdsql.gds.ng.FbBlob.SeekMode-">seek</a></span>(int&nbsp;offset,
    <a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng">FbBlob.SeekMode</a>&nbsp;seekMode)</code>
<div class="block">Performs a seek on a blob with the specified <code>seekMode</code> and <code>offset</code>.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.org.firebirdsql.gds.ng.listeners.ExceptionListenable">
<!--   -->
</a>
<h3>Methods inherited from interface&nbsp;org.firebirdsql.gds.ng.listeners.<a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListenable</a></h3>
<code><a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#addExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">addExceptionListener</a>, <a href="../../../../org/firebirdsql/gds/ng/listeners/ExceptionListenable.html#removeExceptionListener-org.firebirdsql.gds.ng.listeners.ExceptionListener-">removeExceptionListener</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="NO_BLOB_ID">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>NO_BLOB_ID</h4>
<pre>static final&nbsp;long NO_BLOB_ID</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../../constant-values.html#org.firebirdsql.gds.ng.FbBlob.NO_BLOB_ID">Constant Field Values</a></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getBlobId--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBlobId</h4>
<pre>long&nbsp;getBlobId()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The Firebird blob id</dd>
</dl>
</li>
</ul>
<a name="getHandle--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHandle</h4>
<pre>int&nbsp;getHandle()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The Firebird blob handle identifier</dd>
</dl>
</li>
</ul>
<a name="getDatabase--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabase</h4>
<pre><a href="../../../../org/firebirdsql/gds/ng/FbDatabase.html" title="interface in org.firebirdsql.gds.ng">FbDatabase</a>&nbsp;getDatabase()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The database connection that created this blob</dd>
</dl>
</li>
</ul>
<a name="open--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>open</h4>
<pre>void&nbsp;open()
   throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Opens an existing input blob, or creates an output blob.</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If the blob is already open, this is a (closed) output blob and it already has a blobId, the
         transaction is not active, or a database connection error occurred</dd>
</dl>
</li>
</ul>
<a name="isOpen--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOpen</h4>
<pre>boolean&nbsp;isOpen()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this blob is currently open.</dd>
</dl>
</li>
</ul>
<a name="isEof--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isEof</h4>
<pre>boolean&nbsp;isEof()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this blob has reached the end or has been closed, always <code>true</code> for an
 open output blob.</dd>
</dl>
</li>
</ul>
<a name="close--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>void&nbsp;close()
    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Closes the blob.
 <p>
 Closing an already closed blob is a no-op.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true#close--" title="class or interface in java.lang">close</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/AutoCloseable.html?is-external=true" title="class or interface in java.lang">AutoCloseable</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If the transaction is not active, or a database connection error occurred</dd>
</dl>
</li>
</ul>
<a name="cancel--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cancel</h4>
<pre>void&nbsp;cancel()
     throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Cancels an output blob (which means its contents will be thrown away).
 <p>
 Calling cancel on an input blob will close it. Contrary to <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#close--"><code>close()</code></a>, calling cancel on an
 already closed (or cancelled) blob will throw an <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql"><code>SQLException</code></a>.
 </p></div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If the blob has already been closed, the transaction is not active, or a database connection error
         occurred.</dd>
</dl>
</li>
</ul>
<a name="isOutput--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOutput</h4>
<pre>boolean&nbsp;isOutput()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this is an output blob (write only), <code>false</code> if this is an
 input blob (read only)</dd>
</dl>
</li>
</ul>
<a name="getSynchronizationObject--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSynchronizationObject</h4>
<pre><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;getSynchronizationObject()</pre>
<div class="block">Get synchronization object.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>object, cannot be <code>null</code>.</dd>
</dl>
</li>
</ul>
<a name="getSegment-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSegment</h4>
<pre>byte[]&nbsp;getSegment(int&nbsp;sizeRequested)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Gets a segment of blob data.
 <p>
 When <code>sizeRequested</code> exceeds <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getMaximumSegmentSize--"><code>getMaximumSegmentSize()</code></a> it is silently reduced to the maximum
 segment size.
 </p>
 TODO: Consider allowing this and have the implementation handle longer segments by sending multiple (batched?) requests.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sizeRequested</code> - Requested segment size (> 0).</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Retrieved segment (size may be less than requested)</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this is an output blob, the blob is closed, the transaction is not active, or a database connection
         error occurred.</dd>
</dl>
</li>
</ul>
<a name="putSegment-byte:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>putSegment</h4>
<pre>void&nbsp;putSegment(byte[]&nbsp;segment)
         throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Writes a segment of blob data.
 <p>
 Implementation must handle segment length exceeding <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getMaximumSegmentSize--"><code>getMaximumSegmentSize()</code></a> by batching. TODO: reconsider and let caller handle that?
 </p>
 <p>
 Passing a section that is length 0 will throw an <code>SQLException</code>.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>segment</code> - Segment to write</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this is an input blob, the blob is closed, the transaction is not active, the segment is length 0 or
         longer than the maximum segment size, or a database connection error occurred.</dd>
</dl>
</li>
</ul>
<a name="seek-int-org.firebirdsql.gds.ng.FbBlob.SeekMode-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>seek</h4>
<pre>void&nbsp;seek(int&nbsp;offset,
          <a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng">FbBlob.SeekMode</a>&nbsp;seekMode)
   throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Performs a seek on a blob with the specified <code>seekMode</code> and <code>offset</code>.
 <p>
 Firebird only supports seek on stream blobs.
 </p></div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>offset</code> - Offset of the seek, effect depends on value of <code>seekMode</code></dd>
<dd><code>seekMode</code> - Value of <a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng"><code>FbBlob.SeekMode</code></a></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If the blob is closed, the transaction is not active, or a database error occurred.</dd>
</dl>
</li>
</ul>
<a name="getMaximumSegmentSize--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMaximumSegmentSize</h4>
<pre>int&nbsp;getMaximumSegmentSize()</pre>
<div class="block">The maximum segment size allowed by the protocol for <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#getSegment-int-"><code>getSegment(int)</code></a> and <a href="../../../../org/firebirdsql/gds/ng/FbBlob.html#putSegment-byte:A-"><code>putSegment(byte[])</code></a>.
 <p>
 This value is <strong>not</strong> the segment size (optionally) defined for the column.
 </p></div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The maximum segment size allowed for get or put.</dd>
</dl>
</li>
</ul>
<a name="getBlobInfo-byte:A-int-org.firebirdsql.gds.ng.InfoProcessor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBlobInfo</h4>
<pre>&lt;T&gt;&nbsp;T&nbsp;getBlobInfo(byte[]&nbsp;requestItems,
                  int&nbsp;bufferLength,
                  <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng">InfoProcessor</a>&lt;T&gt;&nbsp;infoProcessor)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Request blob info.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dd><code>infoProcessor</code> - Implementation of <a href="../../../../org/firebirdsql/gds/ng/InfoProcessor.html" title="interface in org.firebirdsql.gds.ng"><code>InfoProcessor</code></a> to transform
         the info response</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Transformed info response of type T</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For errors retrieving or transforming the response.</dd>
</dl>
</li>
</ul>
<a name="length--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>length</h4>
<pre>long&nbsp;length()
     throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Requests the blob length from the server.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Length of the blob.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - For Errors retrieving the length, or if the blob is not associated with a blob id, or the database is not
         attached.</dd>
</dl>
</li>
</ul>
<a name="getBlobInfo-byte:A-int-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getBlobInfo</h4>
<pre>byte[]&nbsp;getBlobInfo(byte[]&nbsp;requestItems,
                   int&nbsp;bufferLength)
            throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Request blob info.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>requestItems</code> - Array of info items to request</dd>
<dd><code>bufferLength</code> - Response buffer length to use</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Response buffer</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/firebirdsql/gds/ng/FbAttachment.html" title="interface in org.firebirdsql.gds.ng"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../org/firebirdsql/gds/ng/FbBlob.SeekMode.html" title="enum in org.firebirdsql.gds.ng"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/firebirdsql/gds/ng/FbBlob.html" target="_top">Frames</a></li>
<li><a href="FbBlob.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
